<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 07/17/2004 *
 * ================                             Last change: 07/17/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : ext-mods.php                                     *
 * -------------------------------------------------------------------- *
 * Short description : Module management (mod_reg table)                *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Modul-Management (Tabelle mod_reg)               *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
}

// Version number
setThisExtensionVersion('0.0.8');

// Version history array (add more with , '0.1.0' and so on)
setExtensionVersionHistory(array('0.0', '0.0.1', '0.0.2', '0.0.3', '0.0.4', '0.0.5', '0.0.6', '0.0.7', '0.0.8'));

switch (getExtensionMode()) {
	case 'register': // Do stuff when installation is running (modules.php?module=admin is called)
		// SQL commands to run
		addExtensionSql("INSERT INTO `{?_MYSQL_PREFIX?}_admin_menu` (`action`,`what`,`title`,`descr`,`sort`) VALUES ('mods', NULL, 'Modul-Management','Verwalten Sie die Basis-Module index, login, admin usw.', 4)");
		addExtensionSql("INSERT INTO `{?_MYSQL_PREFIX?}_admin_menu` (`action`,`what`,`title`,`descr`,`sort`) VALUES ('mods','config_mods','Module &auml;ndern','&Auml;ndern Sie hier die Zugtiffsrechte auf die Module. Was dennoch nicht geht: Mitglied- oder Gastzugriffsrtechte auf Admin-Module bzw. Gastzugriffsrechte auf Mitglieder-Module. Diese sind extra abgesichert.', 1)");
		addExtensionSql("INSERT INTO `{?_MYSQL_PREFIX?}_admin_menu` (`action`,`what`,`title`,`descr`,`sort`) VALUES ('mods','stats_mods','Modul-Statistiken','Sehen Sie sich hier die Statistiken der Module und die damit verkn&uuml;pften action- und what-Dateien an. Bei einigen Modulen gibt es allerdings keine verkn&uuml;pften Dateien und somit keine Extra-Statistik.', 2)");
		break;

	case 'remove': // Do stuff when removing extension
		// SQL commands to run
		addExtensionSql("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_admin_menu` WHERE `action`='mods'");
		break;

	case 'activate': // Do stuff when admin activates this extension
		// SQL commands to run
		addExtensionSql('');
		break;

	case 'deactivate': // Do stuff when admin deactivates this extension
		// SQL commands to run
		addExtensionSql('');
		break;

	case 'update': // Update an extension
		switch (getCurrentExtensionVersion())
		{
			case '0.0.2': // SQL queries for v0.0.2
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Fehler beseitigt, wenn error_reporting=E_ALL gesetzt ist.");
				break;

			case '0.0.3': // SQL queries for v0.0.3
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Dummy-Release im Internet???");
				break;

			case '0.0.4': // SQL queries for v0.0.4
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Seit <strong>Patch 340</strong> &uuml;berfl&uuml;ssige HTML-Tags entfernt.");
				break;

			case '0.0.5': // SQL queries for v0.0.5
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("HTML-Code ausgelagert in Templates und SQL-Anweisungen abgesichert.");
				break;

			case '0.0.6': // SQL queries for v0.0.6
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Abspeichern von Einstellungen repariert.");
				break;

			case '0.0.7': // SQL queries for v0.0.7
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Sicherheitsupdate f&uuml;r die Include-Befehle.");
				break;

			case '0.0.8': // SQL queries for v0.0.8
				addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_admin_menu` SET title = 'Modul-Management' WHERE action = 'mods' AND (`what`='' OR `what` IS NULL) LIMIT 1");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Verwaltung auf Management umgestellt.");
				break;
		}
		break;

	case 'modify': // When the extension got modified
		break;

	case 'test': // For testing purposes. For details see file inc/modules/admin/what-extensions.php, arround line 305.
		break;

	case 'init': // Do stuff when extension is initialized
		break;

	default: // Unknown extension mode
		DEBUG_LOG(__FILE__, __LINE__, sprintf("Unknown extension mode %s detected.", getExtensionMode()));
		break;
}

// [EOF]
?>
